package com.zcxk.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;

import com.zcxk.dto.UserDto;
import com.zcxk.entity.MenuEntity;
import com.zcxk.entity.Org;
import com.zcxk.entity.User;
import com.zcxk.model.Permission;
import com.zcxk.model.ProgramItem;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 用户(User)表数据库访问层
 *
 * @author makejava
 * @since 2020-10-21 15:23:51
 */
@Mapper
public interface UserMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    User selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<User> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param user 实例对象
     * @return 对象列表
     */
    List<User> selectList(User user);

    /**
     * 新增数据
     *
     * @param user 实例对象
     * @return 影响行数
     */
    int insert(User user);

    /**
     * 批量新增
     *
     * @param users 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(List<User> users);

    /**
     * 修改数据
     *
     * @param user 实例对象
     * @return 影响行数
     */
    int update(User user);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<User> selectPage(IPage<User> page, User user);
    List<Permission>findPermission(User user);
    List<ProgramItem>findOrgRole(User user);
    List<Org>findOrgs(Org org);


    List<UserDto> findLoginInfo(UserDto user);

    /**
     * 新增注册数据
     * @author yjy
     * @param user 实例对象
     * @return 影响行数
     */
    int insertRegister(User user);
    List<MenuEntity> findUserFirstMenu(@Param("tenantId") String tenantId, @Param("userId") Integer userId);

    List<MenuEntity> findAllFirstMenu();

    List<MenuEntity> findTenantFirstMenu(String tenantId);

    String getUniqueUserID(Integer id);

    String getAppSecret(String appId);

    void updateUniqueUserID(@Param("id")Integer id, @Param("uid") String uid);

    User findThirdPartytLoginInfo(@Param("userId")Integer userId);
}